#!/bin/bash

################################################################################
## Programmname:  mp3aufnehmen.sh                                             ##
##                                                                            ##
## Autor:         Joachim Jakob Kronberg-Gymnasium Aschaffenburg 2016         ##
##                                                                            ##
## Vorbereitung:  Die Audio-Ausgabe wird z.B. auf Analog-Stereo-Out           ##
##                eingestellt                                                 ##
##                                                                            ##
## Kurzanleitung: 1. Speichere diese Datei ins Desktop bzw. ins               ##
##                   Schreibtisch-Verzeichnis                                 ##
##                2. Öffne ein Terminalfenster und wechsle hinein mit:        ##
##                     cd ~/Desktop                                           ##
##                   # bzw. mit:                                              ##
##                     cd ~/Schreibtisch                                      ##
##                3. Mache die Datei ausführbar mit:                          ##
##                     chmod +x mp3aufnehmen.sh                               ##
##                4. Öffne nun z.B. https://translate.google.com              ##
##                   wähle die Sprache aus und gib einen Text dort ein        ##
##                   Schülern kann dieser Text auch bereitgestellt werden mit ## 
##                   http://quizdidaktik.de/dassprechendearbeitsblatt-editor/ ##
##                5. Starte im Terminal das Aufnahme-Programm mit:            ##
##                     ./mp3aufnehmen.sh                                      ##
##                6. Starte möglichst schnell im Browserfenster das Abspielen ##
##                7. Wenn der Text fertig ist, bzw.                           ##
##                   sobald die Aufnahme gestoppt werden soll,                ##
##                   muss das Terminalfenster fokussiert werden               ##
##                   (z.B. durch Anlicken) und dann kann die                  ##
##                   Aufnahme gestoppt werden mit der Tastenkombination:      ##
##                      Strg+C                                                ##
##                8. Auf dem Desktop ist nun eine neue Datei sichtbar:        ##
##                      Aufnahme_JJJJ-MM-DD_hh-mm-ss.mp3                      ##
## Benötigt:      Linux-Distribution (z.B. Ubuntu-Mate) mit                   ##
##                gstreamer, lame                                             ##
################################################################################

## Zeitstempel für den Dateinamen
datum="$(date +%Y-%m-%d_%H-%M-%S)"

## Festlegen, welcher Soundkartenkanal als Quelle gewählt wird
## ein möglicher Wert könnte z.B. lauten: 
## alsa_output.pci-0000_00_1b.0.analog-stereo.monitor
mein_monitor=$(pactl list | grep Name | grep monitor | grep analog |awk -F: '{print $2}' | tr -s " " "\n" | tail -n1)

echo "###############################################"
echo "## Als Soundkanal wurde gewählt:             ##"
echo "## ${mein_monitor}"
#echo "## Die Aufnahme wird in 5 Sekunden gestartet ##"
echo "###############################################"
#for i in {5..1}; do
#    echo "$i"
#    sleep 1
#done
#echo "Start"
echo " "
echo "###############################################"
#echo "## Starte sofort nach dem Countdown          ##"
#echo "## das Abspielen im Webbrowser               ##"
#echo "## Warte, bis das Abspielen fertig ist       ##"
echo "## druecke Strg+C um die Aufnahme zu beenden ##"
echo "###############################################"
echo " "

## deaktivierte Variante für OGG-Vorbis-Audiodateien
#gst-launch-1.0 pulsesrc device=${mein_monitor} ! vorbisenc ! oggmux ! filesink location=out.oga

## aktivierter Standardfall für MP3-Audiodateien
gst-launch-1.0 pulsesrc device=${mein_monitor} ! audioconvert ! lamemp3enc ! filesink location=Aufnahme_${datum}.mp3




